<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Models\TransferioModel;
use App\Http\Models\StgpelniiotintModel;
use App\Http\Models\SyncUtilities\SyncHandlersModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;

class TransferioService extends BaseService
{
	/**
     TransferioService constructor.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->model = new TransferioModel();
	}

	/**
	 *  index function that get all data from database by default
	 *  @return array|static[]
	 */
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	 *  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	 *  @param array $input
	 *  @return array
	 */
	public function paging($request)
	{
		$auth = json_decode($request->session()->get('auth'));

		$this->model->joinRelationVoyageKode()->joinRelationToKapalId()->joinRelationFromKapalId()->getQuery()->select([
			"transferio.id as id",
			"transferio.ioNumber as ioNumber",
			"fromKapalId.namaKapal as fromNamaKapal",
			"toKapalId.id as toKapalId",
			"toKapalId.namaKapal as toNamaKapal",
			"transferio.jlhBarang as jlhBarang",
			"transferio.expectedReceivedDate as expectedReceivedDate",
			"transferio.status as status",
			"transferio.voyageKode as voyageKode",
			"transferio.voyageStart as voyageStart",
			"transferio.voyageEnd as voyageEnd",
			"voyageKode.voyageName as voyageName"
		]);
		if ($auth->aplikasi != "HO") {
			$this->model->getQuery()->where("transferio.fromKapalId", "=", $auth->kapalId);
		}

		$this->model->getQuery()->whereIn("transferio.ioNumber", function ($query) use ($auth) {
			$query->select('itempindahbarangio.ioNumber')
				->from('itempindahbarangio')
				->join("item", function ($join) {
					$join->on("item.id", "=", "itempindahbarangio.itemId");
					$join->on("item.kapalId", "=", "transferio.fromKapalId");
				})
				// "item.id", "=", "itempindahbarangio.itemId")
				->whereIn("item.type_id", $auth->arrCategory)
				->whereIn("itempindahbarangio.fromLokasiId", $auth->arrLokasi)
				->whereIn("itempindahbarangio.lokasiId", $auth->arrLokasi);
		});

		$input = $request->all();
		if (!isset($input["sort"])) {
			$this->model->getQuery()->orderBy("transferio.date_updated", "desc");
		}

		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	/**
	 *  get one raw row data from table by id
	 *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	 *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	 *  and you want to take value like this $model->fieldname
	 *  @param $id
	 *  @return TransferioModel
	 */
	public function show($id)
	{
		$model = $this->model->joinRelationVoyageKode()->joinRelationToKapalId()->getQuery()
			->select([
				"transferio.*",
				"toKapalId.id as toKapalId",
				"toKapalId.namaKapal as toNamaKapal",
				"voyageKode.voyageName as voyageName"
			])
			->where("transferio.id", "=", $id)
			->first();
		return $model;
	}


	public function showByTransactionNo($noTransaction)
	{
		$model = $this->model->joinRelationRequesterId()->joinRelationVoyageKode()->joinRelationToKapalId()->getQuery()
			->select([
				"transferio.*",
				//			"toKapalId.id as toKapalId",
				"toKapalId.namaKapal as toNamaKapal",
				"requesterId.jabatan as requesterJabatan",
				"voyageKode.voyageName as voyageName"
			])
			->where("transferio.ioNumber", "=", $noTransaction)
			->first();
		return $model;
	}


	/**
	 *  this is a base function for storing data you with transaction by default
	 *  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	 *  @param array $input
	 *  @return TransferioModel
	 *  @throws \Exception
	 */
	public function store($input)
	{
		$jlhBarang = 0;

		if (isset($input["quantity"])) {
			$jlhBarang = array_sum($input["quantity"]);
		}
		$input["jlhBarang"] = $jlhBarang;
		$input["approverId"] = 0;
		$input["fromLocationId"] = 0;
		$input["toLocationId"] = 0;
		$input["toOrganization"] = "-";

		$transactionBrg = new TransferioModel();
		$transactionBrg->fill($input);
		if (!$transactionBrg->save()) {
			throw new \Exception();
		}
		return $transactionBrg->id;
	}


	/**
	 * this function will delete much data, in one action
	 * the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	 * you can remove this main alogorithm with your business requirement like soft delete or anything you want
	 *  @param $ids
	 */
	public function delete($ids)
	{
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	 *  this is a base function for update and delete data by default.
	 *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	 *  you can add multiple relation proses after update in this function 
	 *  @param $id
	 *  @param array $input 
	 *  @return TransferioModel
	 *  @throws \Exception
	 */
	public function update($id, $input)
	{
		$transferio = TransferioModel::find($id);
		$transferio->fill($input);
		if (!$transferio->update()) {
			throw new \Exception();
		}
		return $transferio;
	}


	/**
	 *  this function will be confirting paging property into file excel
	 *  the main library is base on excel spreadsheet library
	 *  @param array $input
	 *   @return array|static[]
	 */
	public function exportToExcel($input = array())
	{
		return $this->model->getQuery()->get();
	}


	public function getLastestID($prefix)
	{
		$getMaxID = $this->model->getQuery()->selectRaw('MAX(SUBSTRING("transferio"."ioNumber", 9, 6)) AS "ioNumber"')->where("transferio.ioNumber", "ILIKE", $prefix . "%")->first();
		if ($getMaxID || true) {
			return $prefix . substr("000000" . ($getMaxID->ioNumber + 1), -6);
		} else {
			return $prefix . "000001";
		}
	}


	public function approve($input)
	{
		$dateTimeApproved = date("Y-m-d H:i:s");
		$newInput = [
			"approverId" => $input["approverId"],
			"feedback" => $input["feedback"],
			"tglApproved" => $dateTimeApproved,
			"date_updated" => $dateTimeApproved,
			"status" => $input["status"]
		];
		$transferio = TransferioModel::where("ioNumber", $input["ioNumber"]);
		if (!$transferio->update($newInput)) {
			throw new \Exception();
		}

		$needSync = $transferio->first();
		$sync = SyncHandlersModel::where("sync.local_id", "=", $needSync->id)
			->where("sync.table_name", "=", "pindahbarangio");
		if (!$sync->update(["need_sync" => 1])) {
			throw new \Exception();
		}

		return $transferio;
	}

	public function saveStaging($staging)
	{
		$data = [];
		$totalLine = count($staging["footer"]);

		foreach ($staging["footer"] as $row) {
			$data[] =  [
				"transaction_number"			=> $staging["header"]->ioNumber,
				"last_update_date"				=> $staging["header"]->date_updated,
				"creation_date"					=> $staging["header"]->tglTransaksi,
				"organization_id"				=> $staging["header"]->fromKapalId,
				"transaction_date"				=> $staging["header"]->tglTransaksi,
				"subinventory_code"				=> $row->fromNamaLokasi,
				"to_org_id"						=> $staging["header"]->toKapalId,
				"voyage_call"					=> $staging["header"]->voyageKode,
				"to_subinventory"				=> $row->namaLokasi,
				"inout"							=> "OUT",
				"process_flag"					=> 1,
				"transaction_mode"				=> 3,
				"lock_flag"						=> 2,

				"inventory_item_id"				=> $row->itemId,
				"item_segment1"					=> $row->namaItem,
				"transaction_quantity"			=> $row->quantity,
				"transaction_uom"				=> $row->UOM,
				"attribute2"					=> $row->lotNumber,
				"transaction_source_type_id"	=> 13,

				"attribute14"					=> $staging["header"]->requesterJabatan,
				"total_line"					=> $totalLine
			];
		}

		foreach ($data as $dat) {
			$stagingModel = new StgpelniiotintModel();
			$stagingModel->fill($dat);
			if (!$stagingModel->save()) {
				throw new \Exception();
			}
		}
	}
}
